#!/usr/bin/env python
#-*- coding: UTF-8 -*-

import wx

from   .nofyhistmisc import *

class FindDialog(wx.Dialog):
    
    def __init__(self, parent, config, messageshistory, updateListwin):        
        wx.Dialog.__init__(self, parent, -1, TITLE + _(' - find message entry'))
        btnadj = int(config['Gui']['norm'] == 'False')
        paramhist = config['Misc']['paramhist']
        self.paramhist = paramhist
        self.messageshistory = messageshistory
        self.updateListwin = updateListwin
        txt = _(" Enter (sub)string to search for ") 

        sizer = wx.BoxSizer(wx.VERTICAL)
        box1 = wx.StaticBox(self, -1, txt)
        bsz1 = wx.StaticBoxSizer(box1, wx.VERTICAL)
        self.cbx = wx.ComboBox(self, -1, paramhist[0],
                               choices = paramhist,
                               style = wx.TE_PROCESS_ENTER)        
        bsz1.Add(self.cbx, 0, wx.ALL | wx.GROW, GAP)
        self.Bind(wx.EVT_TEXT, self.onText, self.cbx)
        self.Bind(wx.EVT_COMBOBOX, self.onText, self.cbx)
        self.Bind(wx.EVT_TEXT_ENTER, self.onOk, self.cbx)
        self.cbx.SetMark(0, -1)
        self.cbx.SetFocusFromKbd()

        butok = wx.Button(self, wx.ID_OK)
        self.Bind(wx.EVT_BUTTON, self.onOk, id = wx.ID_OK)
        butcancel = wx.Button(self, wx.ID_CANCEL)
        row2 = wx.BoxSizer(wx.HORIZONTAL)
        if not btnadj: row2.AddStretchSpacer()
        row2.Add(butok, btnadj, wx.GROW | wx.ALL, GAP)
        row2.Add(butcancel, btnadj, wx.GROW | wx.ALL, GAP)
    
        sizer.Add(bsz1, 0, wx.GROW | LRT, BORDER)
        
        sizer.Add(row2, 0, wx.GROW | wx.ALL, GAP)
        self.SetSizer(sizer)
        self.SetMinSize(wx.Size(350, -1))
        self.Fit()
        self.Centre()
        self.onText()
    #-------------------------------------------------------------------------------------------
  
    def onText(self, event = None):
        mask = self.cbx.GetValue().lower()
        if len(mask):
            indexes = []
            for index, line in enumerate(self.messageshistory):
                if mask in line[0].lower() or mask in line[1].lower() or mask in line[2].lower():
                    indexes.append(index)
                self.updateListwin(False, indexes)
        else:
            self.updateListwin()
    #-------------------------------------------------------------------------------------------
                
    def onOk(self, event):
        txtitem = self.cbx.GetValue()
        if not txtitem:
            txtitem = self.paramhist[0]
            self.cbx.SetValue(txtitem)
            
        if txtitem != self.paramhist[0]:
            if txtitem in self.paramhist:
                self.paramhist.remove(txtitem)
            self.paramhist.insert(0, txtitem)
            if len(self.paramhist) == 9:
                del self.paramhist[8]
            self.cbx.Clear()
            for item in self.paramhist:
                self.cbx.Append(item)
            self.cbx.SetValue(txtitem)

        self.EndModal(wx.ID_OK)
    #-------------------------------------------------------------------------------------------

    def getValue(self):
        return self.paramhist
# - class FindDialog(wx.Dialog):--------------------------------------------------------------
    
